## qtcreator 18.0.0

=== dist/CMakeLists.txt ===
# copy resource directories during build
qtc_copy_to_builddir(copy_changelog_to_builddir
  DIRECTORIES changelog
  DESTINATION "${IDE_DATA_PATH}"
  CREATE_SUBDIRS
)

install(
  DIRECTORY changelog
  DESTINATION ${IDE_DATA_PATH}
)

file(GLOB_RECURSE changelog_files RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" "changelog/*")

qtc_add_sbom(Changelog
    TYPE RESOURCES
)

qtc_sbom_add_files(Changelog
    FILES "${changelog_files}"
    FILE_TYPE "RESOURCES"
    INSTALL_PATH "${IDE_DATA_PATH}/changelog"
)

=== doc/CMakeLists.txt ===
# Generate documentation

option(BUILD_DEVELOPER_DOCS "Include developer documentation" OFF)
add_feature_info("Include developer documentation" BUILD_DEVELOPER_DOCS "")

function(_find_all_includes _ret_includes _ret_framework_paths)
  set(_all_includes "${PROJECT_SOURCE_DIR}/src/plugins;${PROJECT_SOURCE_DIR}/src/libs")
  foreach(_target ${__QTC_PLUGINS} ${__QTC_LIBRARIES})
    if (NOT TARGET ${_target})
      continue()
    endif()
    get_target_property(_includes ${_target} INCLUDE_DIRECTORIES)
    foreach(_include ${_includes})
      string(FIND "${_include}" "/src/plugins/" _in_plugins)
      string(FIND "${_include}" "/src/libs/" _in_libs)
      string(FIND "${_include}" "${CMAKE_BINARY_DIR}" _in_build)
      string(REGEX MATCH "\\$<TARGET_PROPERTY:([^,]+).*>" _property_match "${_include}")
      set(_property_target "${CMAKE_MATCH_1}")
      if(_in_plugins LESS 0 AND _in_libs LESS 0 AND _in_build LESS 0 AND (NOT _property_target OR TARGET ${_property_target}))
        list(APPEND _all_includes ${_include})
      endif()
    endforeach()
  endforeach()
  list(APPEND _all_includes ${CMAKE_CXX_IMPLICIT_INCLUDE_DIRECTORIES})
  list(REMOVE_DUPLICATES _all_includes)
  set("${_ret_includes}" "${_all_includes}" PARENT_SCOPE)

  # framework path
  if (APPLE)
    get_target_property(_qt_type Qt::Core TYPE)
    if ("${_qt_type}" STREQUAL "INTERFACE_LIBRARY")
        # version-less target Qt::Core is an interface library that links to QtX::Core
        get_target_property(_qt_core Qt::Core INTERFACE_LINK_LIBRARIES)
    else()
        set(_qt_core "Qt::Core")
    endif()
    get_target_property(_qt_target ${_qt_core} LOCATION)
    # eg <fw_path>/QtCore.framework/QtCore
    # or <fw_path>/QtCore.framework/Versions/A/QtCore
    # cut off /QtCore.framework/*
    string(REGEX REPLACE "/QtCore.framework/.*" "" _qt_loc "${_qt_target}")
    set("${_ret_framework_paths}" "${_qt_loc}" PARENT_SCOPE)
  endif()
endfunction()

function(_add_doc _doc_file _dev_doc_file)
  set(GENERATED_ATTRIBUTIONS_DIR ${CMAKE_CURRENT_BINARY_DIR}/generated_attributions)
  add_qtc_documentation(${_doc_file}
    ENVIRONMENT_EXPORTS GENERATED_ATTRIBUTIONS_DIR
  )
  set(attribution_src "${CMAKE_CURRENT_SOURCE_DIR}/../qt_attributions.json")
  set(attribution_dest "${CMAKE_CURRENT_BINARY_DIR}/qt_attributions.json")
  qtc_prepare_attribution_file("${attribution_src}" "${attribution_dest}")
  add_qtc_doc_attribution(doc_attributions
    "${attribution_dest}"
    "${GENERATED_ATTRIBUTIONS_DIR}/creator-attributions.qdoc"
    ${_doc_file}
  )
  if (Qt6_VERSION VERSION_GREATER_EQUAL 6.8.0)
    set(litehtml_attributions "${CMAKE_CURRENT_SOURCE_DIR}/../src/libs/qlitehtml/src/3rdparty/qt_attribution.json")
    if(EXISTS "${litehtml_attributions}")
      add_qtc_doc_attribution(doc_attributions_litehtml
        "${litehtml_attributions}"
        "${GENERATED_ATTRIBUTIONS_DIR}/creator-attributions-litehtml.qdoc"
        ${_doc_file}
      )
    endif()
  else()
    message(WARNING "Disabling qt_attribution.json handling for qlitehtml for Qt < 6.8.0")
  endif()
  if (BUILD_DEVELOPER_DOCS)
    _find_all_includes(_all_includes _framework_paths)
    add_qtc_documentation(${_dev_doc_file}
      INCLUDE_DIRECTORIES ${_all_includes}
      FRAMEWORK_PATHS ${_framework_paths}
    )
  endif()
endfunction()

if (WITH_DOCS)
  _add_doc(${IDE_DOC_FILE} "qtcreatordev/qtcreator-dev.qdocconf")
endif()
if(WITH_ONLINE_DOCS)
  _add_doc(${IDE_DOC_FILE_ONLINE} "qtcreatordev/qtcreator-dev-online.qdocconf")
endif()

if (BUILD_DOCS_BY_DEFAULT)
set(EXCLUDE_DOCS_FROM_ALL "")
else()
set(EXCLUDE_DOCS_FROM_ALL "EXCLUDE_FROM_ALL")
endif()

install(DIRECTORY config
  DESTINATION ${IDE_HEADER_INSTALL_PATH}/doc
  COMPONENT Devel
  ${EXCLUDE_DOCS_FROM_ALL}
)

=== src/app/CMakeLists.txt ===
configure_file(app_version.h.cmakein app_version.h ESCAPE_QUOTES)

if(NOT IS_ABSOLUTE "${IDE_ICON_PATH}")
  set(IDE_ICON_PATH "${CMAKE_CURRENT_SOURCE_DIR}/${IDE_ICON_PATH}")
endif()

if (NOT IS_ABSOLUTE ${IDE_LOGO_PATH})
  set(IDE_LOGO_PATH "${CMAKE_CURRENT_SOURCE_DIR}/${IDE_LOGO_PATH}")
endif()
configure_file(app_logo.qrc.cmakein app_logo_cmake.qrc)

# This needs to be explicit like this, to avoid issues with the path
# to the binary in generated SBOMs.
set(qtcreator_props "")
if(APPLE)
  list(APPEND qtcreator_props MACOSX_BUNDLE ON)
endif()
if(WIN32)
  list(APPEND qtcreator_props WIN32_EXECUTABLE ON)
endif()
add_qtc_executable(qtcreator
  DEFINES
    IDE_LIBRARY_BASENAME=\"${IDE_LIBRARY_BASE_PATH}\"
    IDE_APP_ID=\"${IDE_APP_ID}\"
  DEPENDS Aggregation ExtensionSystem Qt::Core Qt::Widgets Utils shared_qtsingleapplication app_version
  SOURCES
    main.cpp
    ${CMAKE_CURRENT_BINARY_DIR}/app_logo_cmake.qrc
    ../tools/qtcreatorcrashhandler/crashhandlersetup.cpp ../tools/qtcreatorcrashhandler/crashhandlersetup.h
  PROPERTIES
    ${qtcreator_props}
    OUTPUT_NAME "${IDE_APP_TARGET}"
  DESTINATION "${IDE_APP_PATH}"
  QTC_RUNNABLE
)

extend_qtc_executable(qtcreator
  CONDITION APPLE
  DEPENDS ${FWFoundation}
  SOURCES
    main_mac.mm
)

if (NOT TARGET qtcreator)
  return()
endif()

if (QTC_STATIC_BUILD)
  set(plugins_to_import "")
  set(source_file_content "#include <QtPlugin>\n")
  foreach(plugin IN LISTS __QTC_PLUGINS)
    if(TARGET ${plugin})
      list(APPEND plugins_to_import "${plugin}")
      # TODO ${plugin}Plugin is not correct for all plugins as the class name
      get_target_property(plugin_class ${plugin} QTC_PLUGIN_CLASS_NAME)
      string(APPEND source_file_content "Q_IMPORT_PLUGIN(${plugin_class})\n")
    endif()
  endforeach()

  string(APPEND source_file_content
    "struct ResourcesInitializer {\n"
    "  ResourcesInitializer() {\n")
  foreach(resource_file IN LISTS __QTC_RESOURCE_FILES)
     string(APPEND source_file_content "    Q_INIT_RESOURCE(${resource_file});\n")
  endforeach()
  string(APPEND source_file_content
    "  }\n"
    "} g_resources_initializer;\n")

  file(GENERATE
    OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/plugin_imports.cpp"
    CONTENT "${source_file_content}"
  )
  extend_qtc_target(qtcreator
    DEPENDS ${plugins_to_import}
    SOURCES "${CMAKE_CURRENT_BINARY_DIR}/plugin_imports.cpp"
  )

  if (TARGET QmlDesigner)
    qt6_import_qml_plugins(qtcreator
      PATH_TO_SCAN "${CMAKE_CURRENT_SOURCE_DIR}/../../share/qtcreator/qmldesigner")
  endif()
endif()

if (WIN32)
  set(RC_APPLICATION_NAME "${IDE_DISPLAY_NAME}")
  set(RC_VERSION "${IDE_VERSION}.0")
  set(RC_VERSION_STRING "${IDE_VERSION_DISPLAY}")
  set(RC_COPYRIGHT "${IDE_COPYRIGHT}")
  set(RC_PUBLISHER "${IDE_PUBLISHER}")

  string(REPLACE " " "\\x20" RC_APPLICATION_NAME "${RC_APPLICATION_NAME}")
  string(REPLACE " " "\\x20" RC_PUBLISHER "${RC_PUBLISHER}")
  string(REPLACE " " "\\x20" RC_COPYRIGHT "${RC_COPYRIGHT}")
  string(REPLACE "." "," RC_VERSION "${RC_VERSION}")

  target_compile_definitions(qtcreator PRIVATE
    RC_PUBLISHER=${RC_PUBLISHER}
    RC_APPLICATION_NAME=${RC_APPLICATION_NAME}
    RC_VERSION=${RC_VERSION}
    RC_VERSION_STRING=${RC_VERSION_STRING}
    RC_COPYRIGHT=${RC_COPYRIGHT}
    RC_ICON_PATH=${IDE_ICON_PATH}
  )

  target_sources(qtcreator PRIVATE qtcreator.rc)
endif()

if (APPLE)
  if (CMAKE_OSX_DEPLOYMENT_TARGET)
    set(MACOSX_DEPLOYMENT_TARGET ${CMAKE_OSX_DEPLOYMENT_TARGET})
  endif()
  set_target_properties(qtcreator PROPERTIES
      MACOSX_BUNDLE_INFO_PLIST "${CMAKE_CURRENT_SOURCE_DIR}/app-Info.plist"
  )
  # icon
  add_custom_command(
    OUTPUT qtcreator.icns qtcreator-project.icns
    COMMAND
      xcrun actool --app-icon qtcreator --output-partial-info-plist "${CMAKE_CURRENT_BINARY_DIR}/qtcreator.Info.plist"
      --platform macosx --minimum-deployment-target 10.7 --compile "${CMAKE_CURRENT_BINARY_DIR}"
      "${IDE_ICON_PATH}/qtcreator.xcassets"
      > /dev/null
    BYPRODUCTS qtcreator.Info.plist
    DEPENDS
      qtcreator.xcassets/qtcreator.appiconset/Contents.json
      qtcreator.xcassets/qtcreator.appiconset/icon_128x128.png
      qtcreator.xcassets/qtcreator.appiconset/icon_128x128@2x.png
      qtcreator.xcassets/qtcreator.appiconset/icon_16x16.png
      qtcreator.xcassets/qtcreator.appiconset/icon_16x16@2x.png
      qtcreator.xcassets/qtcreator.appiconset/icon_256x256.png
      qtcreator.xcassets/qtcreator.appiconset/icon_256x256@2x.png
      qtcreator.xcassets/qtcreator.appiconset/icon_32x32.png
      qtcreator.xcassets/qtcreator.appiconset/icon_32x32@2x.png
      qtcreator.xcassets/qtcreator.appiconset/icon_512x512.png
      qtcreator.xcassets/qtcreator.appiconset/icon_512x512@2x.png
      qtcreator.xcassets/qtcreator-project.iconset/icon_128x128.png
      qtcreator.xcassets/qtcreator-project.iconset/icon_128x128@2x.png
      qtcreator.xcassets/qtcreator-project.iconset/icon_16x16.png
      qtcreator.xcassets/qtcreator-project.iconset/icon_16x16@2x.png
      qtcreator.xcassets/qtcreator-project.iconset/icon_256x256.png
      qtcreator.xcassets/qtcreator-project.iconset/icon_256x256@2x.png
      qtcreator.xcassets/qtcreator-project.iconset/icon_32x32.png
      qtcreator.xcassets/qtcreator-project.iconset/icon_32x32@2x.png
      qtcreator.xcassets/qtcreator-project.iconset/icon_512x512.png
      qtcreator.xcassets/qtcreator-project.iconset/icon_512x512@2x.png
    VERBATIM
  )
  target_sources(qtcreator
    PRIVATE
      "${CMAKE_CURRENT_BINARY_DIR}/qtcreator.icns"
      "${CMAKE_CURRENT_BINARY_DIR}/qtcreator-project.icns"
  )
  qtc_copy_to_builddir(copy_icns
    DESTINATION ${IDE_DATA_PATH}
    FILES
      ${CMAKE_CURRENT_BINARY_DIR}/qtcreator.icns
      ${CMAKE_CURRENT_BINARY_DIR}/qtcreator-project.icns
  )
  install(
    FILES
      ${CMAKE_CURRENT_BINARY_DIR}/qtcreator.icns
      ${CMAKE_CURRENT_BINARY_DIR}/qtcreator-project.icns
    DESTINATION ${IDE_DATA_PATH}
  )
endif()

option(QTC_FORCE_XCB "Enables that Qt Creator forces XCB on Linux if QT_QPA_PLATFORM is not set." OFF)
extend_qtc_executable(qtcreator
  CONDITION QTC_FORCE_XCB
  DEFINES
    QTC_FORCE_XCB
)

extend_qtc_executable(qtcreator
  CONDITION BUILD_WITH_CRASHPAD
  DEFINES
    CRASHPAD_BACKEND_URL="${CRASHPAD_BACKEND_URL}"
    ENABLE_CRASHPAD
    WIN32_LEAN_AND_MEAN # It comes usually with precompiled header, but at the installer they are disabled
  DEPENDS Crashpad::Crashpad
)
if(BUILD_WITH_CRASHPAD)
  install(
    PROGRAMS ${CRASHPAD_BIN_DIR}/crashpad_handler${CMAKE_EXECUTABLE_SUFFIX}
    DESTINATION "${IDE_LIBEXEC_PATH}"
  )
endif()

extend_qtc_executable(qtcreator
  CONDITION BUILD_WITH_SENTRY
  DEFINES
    SENTRY_DSN="${SENTRY_DSN}"
    SENTRY_PROJECT="${SENTRY_PROJECT}"
    ENABLE_SENTRY
  DEPENDS sentry::sentry
)
extend_qtc_executable(qtcreator
  CONDITION DEFINED SENTRY_CRASHPAD_PATH
  DEFINES
    SENTRY_CRASHPAD_PATH="${SENTRY_CRASHPAD_PATH}"
)

if ((NOT WIN32) AND (NOT APPLE))
  # install logo
  foreach(size 16 24 32 48 64 128 256 512)
    install(
      FILES ${IDE_LOGO_PATH}/images/logo/${size}/QtProject-${IDE_ID}.png
      DESTINATION share/icons/hicolor/${size}x${size}/apps
    )
  endforeach()
endif()

=== src/libs/CMakeLists.txt ===
add_subdirectory(3rdparty)

add_subdirectory(devcontainer)
add_subdirectory(nanotrace)
add_subdirectory(advanceddockingsystem)
add_subdirectory(aggregation)
add_subdirectory(cplusplus)
add_subdirectory(extensionsystem)
add_subdirectory(glsl)
add_subdirectory(languageserverprotocol)
add_subdirectory(languageutils)
add_subdirectory(modelinglib)
add_subdirectory(qmldebug)
add_subdirectory(qmleditorwidgets)
add_subdirectory(qmljs)
add_subdirectory(qtcreatorcdbext)
add_subdirectory(utils)
add_subdirectory(solutions)
add_subdirectory(tracing)

if (WITH_QMLDESIGNER)
  add_subdirectory(sqlite)
  add_subdirectory(qmlpuppetcommunication)
endif()

if (WITH_TESTS)
 add_subdirectory(googletest)
endif()

add_subdirectory(gocmdbridge)

if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/qlitehtml/src/CMakeLists.txt)
  option(BUILD_LIBRARY_QLITEHTML "Build library qlitehtml." ${BUILD_LIBRARIES_BY_DEFAULT})
  set(QLITEHTML_VERSION_COMPAT ${IDE_VERSION_COMPAT} CACHE STRING "")
  if(BUILD_LIBRARY_QLITEHTML)
    set(QLITEHTML_LIBRARY_ARCHIVE_PATH ${IDE_LIBRARY_ARCHIVE_PATH})
    set(QLITEHTML_EXPORT QtCreator)
    set(QLITEHTML_DEVEL_COMPONENT Devel)
    set(QLITEHTML_DEVEL_EXCLUDE_FROM_ALL ON)
    set(QLITEHTML_HEADER_PATH "${IDE_HEADER_INSTALL_PATH}/src/lib/qlitehtml")
    if (QTC_STATIC_BUILD)
      set(QLITEHTML_LIBRARY_TYPE STATIC)
    else()
      set(QLITEHTML_BIN_PATH ${IDE_BIN_PATH})
      set(QLITEHTML_LIBRARY_PATH ${IDE_LIBRARY_PATH})
    endif()
    set(QT_VERSION_MAJOR ${Qt6_VERSION_MAJOR})
    option(BUILD_TESTING "Build litehtml tests" OFF) # otherwise litehtml downloads googletest
    add_subdirectory(qlitehtml/src)
  endif()
  if(TARGET qlitehtml)
    target_compile_definitions(qlitehtml PRIVATE ${DEFAULT_DEFINES}) # for precompiled headers
    enable_pch(qlitehtml)
    #doesn't work: TARGET 'qlitehtml' was not created in this directory.
    #qtc_enable_separate_debug_info(qlitehtml "${IDE_LIBRARY_PATH}")
    qtc_output_binary_dir(_output_binary_dir)
    set_target_properties(qlitehtml PROPERTIES
      BUILD_RPATH "${_LIB_RPATH};${CMAKE_BUILD_RPATH}"
      INSTALL_RPATH "${_LIB_RPATH};${CMAKE_INSTALL_RPATH}"
      RUNTIME_OUTPUT_DIRECTORY "${_output_binary_dir}/${IDE_BIN_PATH}"
      LIBRARY_OUTPUT_DIRECTORY "${_output_binary_dir}/${IDE_LIBRARY_PATH}"
      ARCHIVE_OUTPUT_DIRECTORY "${_output_binary_dir}/${IDE_LIBRARY_ARCHIVE_PATH}"
    )
  endif()
endif()

=== src/plugins/CMakeLists.txt ===
# Level 0:
add_subdirectory(coreplugin)

# Level 1: (only depends of Level 0)
add_subdirectory(lua)
add_subdirectory(texteditor)
add_subdirectory(serialterminal)
add_subdirectory(extensionmanager)
add_subdirectory(helloworld)
add_subdirectory(imageviewer)
add_subdirectory(screenrecorder)
add_subdirectory(updateinfo)
add_subdirectory(welcome)

# Level 2: (only depends on Level 1 and below)
add_subdirectory(bineditor)
add_subdirectory(cpaster)
add_subdirectory(diffeditor)
add_subdirectory(emacskeys)
add_subdirectory(macros)
add_subdirectory(projectexplorer)
add_subdirectory(silversearcher)

# Level 3: (only depends on Level 2 and below)
add_subdirectory(compilerexplorer)
add_subdirectory(cppeditor)
add_subdirectory(help)
add_subdirectory(resourceeditor)
add_subdirectory(nim)
add_subdirectory(conan)
add_subdirectory(saferenderer)
add_subdirectory(terminal)
add_subdirectory(vcpkg)
add_subdirectory(languageclient)

# Level 4: (only depends on Level 3 and below)
add_subdirectory(classview)
add_subdirectory(glsleditor)
add_subdirectory(modeleditor)
add_subdirectory(qtsupport)
add_subdirectory(todo)
add_subdirectory(vcsbase)

# Level 5:
add_subdirectory(autotoolsprojectmanager)
add_subdirectory(bazaar)
add_subdirectory(beautifier)
add_subdirectory(clearcase)
add_subdirectory(cvs)
add_subdirectory(designer)
add_subdirectory(docker)
add_subdirectory(devcontainer)
add_subdirectory(fakevim)
add_subdirectory(fossil)
add_subdirectory(genericprojectmanager)
add_subdirectory(git)
add_subdirectory(learning)
add_subdirectory(mercurial)
add_subdirectory(mesonprojectmanager)
add_subdirectory(perforce)
add_subdirectory(qmakeprojectmanager)
add_subdirectory(qmljstools)
add_subdirectory(scxmleditor)
add_subdirectory(subversion)
add_subdirectory(compilationdatabaseprojectmanager)
if (WITH_QMLDESIGNER)
  add_subdirectory(qmldesignerbase)
endif()
add_subdirectory(webassembly)

# Level 6:
add_subdirectory(debugger)
add_subdirectory(coco)
add_subdirectory(copilot)
add_subdirectory(gitlab)
add_subdirectory(qmljseditor)
add_subdirectory(python)
add_subdirectory(clangformat)
add_subdirectory(cmakeprojectmanager)

# Level 7:
add_subdirectory(android)
add_subdirectory(autotest)
add_subdirectory(axivion)
add_subdirectory(baremetal)
add_subdirectory(clangcodemodel)
add_subdirectory(clangtools)
add_subdirectory(cppcheck)
add_subdirectory(incredibuild)
add_subdirectory(ios)
add_subdirectory(qmlprofiler)
if (WITH_QMLDESIGNER)
  add_subdirectory(qmlprojectmanager)
endif()
add_subdirectory(remotelinux)
add_subdirectory(valgrind)
add_subdirectory(perfprofiler)
add_subdirectory(qbsprojectmanager)
add_subdirectory(ctfvisualizer)
add_subdirectory(squish)
add_subdirectory(appstatisticsmonitor)

# Level 8:
add_subdirectory(qmlpreview)

# Level 9:
add_subdirectory(boot2qt)
if (WITH_QMLDESIGNER)
  unset(qmldesigner_builddir)
  if (WIN32 AND CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    # Workaround for @CMakeFiles\QmlDesigner.rsp ld.lld.exe: The filename or extension is too long.
    # Clang on Windows is having problems with QmlDesigner.rsp which is bigger than 32KiB
    set(qmldesigner_builddir ${PROJECT_BINARY_DIR}/qmldsgnr)
  endif()
  add_subdirectory(qmldesigner ${qmldesigner_builddir})
  add_subdirectory(qmldesignerlite)
  add_subdirectory(extrapropertyeditormanager)
  add_subdirectory(effectcomposer)
  add_subdirectory(studiowelcome)
  add_subdirectory(insight)
endif()
add_subdirectory(qnx)
add_subdirectory(mcusupport)
add_subdirectory(qtapplicationmanager)

=== src/shared/CMakeLists.txt ===
add_subdirectory(designerintegrationv2)
add_subdirectory(proparser)
add_subdirectory(qtsingleapplication)
add_subdirectory(help)
add_subdirectory(registryaccess)

# PCHs used by qmake based plugin builds
qtc_add_public_header(qtcreator_pch.h)
qtc_add_public_header(qtcreator_gui_pch.h)

option(BUILD_QBS "Build Qbs together with Qt Creator" OFF)
option(WITH_QBS_DOCS "Build Qbs documentation" ${WITH_DOCS})

add_feature_info("Build Qbs" BUILD_QBS "")
if (BUILD_QBS)
  file(RELATIVE_PATH _REL_PATH_TO_QTC "${CMAKE_BINARY_DIR}" "${PROJECT_BINARY_DIR}")
  set(QBS_OUTPUT_PREFIX "${_REL_PATH_TO_QTC}/" CACHE STRING "" FORCE)
  set(QBS_APP_INSTALL_DIR "${IDE_BIN_PATH}" CACHE STRING "" FORCE)
  set(QBS_LIB_INSTALL_DIR "${IDE_LIBRARY_PATH}" CACHE STRING "" FORCE)
  set(QBS_DLL_INSTALL_DIR "${IDE_BIN_PATH}" CACHE STRING "" FORCE)
  set(QBS_LIBEXEC_INSTALL_DIR "${IDE_LIBEXEC_PATH}" CACHE STRING "" FORCE)
  if (APPLE)
    set(QBS_PLUGINS_INSTALL_BASE "${IDE_PLUGIN_PATH}/../" CACHE STRING "" FORCE)
  else()
    set(QBS_PLUGINS_INSTALL_BASE "${_IDE_LIBRARY_BASE_PATH}/" CACHE STRING "" FORCE)
  endif()
  set(QBS_RESOURCES_INSTALL_BASE "${IDE_DATA_PATH}/qbs" CACHE STRING "" FORCE)
  set(QBS_DOC_INSTALL_DIR "${IDE_DOC_PATH}" CACHE STRING "" FORCE)
  set(QBS_HEADERS_INSTALL_DIR "${IDE_DATA_PATH}/qbs/include/qbs" CACHE STRING "" FORCE)

  set(INSTALL_PUBLIC_HEADERS OFF CACHE BOOL "")
  set(WITH_TESTS OFF)
  set(WITH_PROJECT_FILE_UPDATES ON CACHE BOOL "")
  set(QBS_INSTALL_QCH_DOCS ${WITH_QBS_DOCS} CACHE BOOL "")
  add_subdirectory(qbs)
endif()

=== src/tools/CMakeLists.txt ===
add_subdirectory(3rdparty)
add_subdirectory(buildoutputparser)

function(add_qtc_cpp_tool name)
  add_qtc_executable(${name}
    SKIP_INSTALL
    DEFINES
      PATH_PREPROCESSOR_CONFIG=\"${CMAKE_CURRENT_SOURCE_DIR}/cplusplus-shared/pp-configuration.inc\"
      ${ARGN}
    DEPENDS CPlusPlus Utils Qt::Widgets
    INCLUDES "${CMAKE_CURRENT_SOURCE_DIR}/cplusplus-shared"
      "${CMAKE_CURRENT_SOURCE_DIR}/${name}"
    SOURCES
      cplusplus-shared/utils.cpp
      "${name}/${name}.cpp"
  )
endfunction()

add_qtc_cpp_tool(cplusplus-ast2png "")
add_qtc_cpp_tool(cplusplus-frontend "")
add_qtc_cpp_tool(cplusplus-mkvisitor PATH_AST_H=\"${CMAKE_CURRENT_SOURCE_DIR}/../libs/3rdparty/cplusplus/AST.h\")
add_qtc_cpp_tool(cplusplus-update-frontend PATH_CPP_FRONTEND=\"${CMAKE_CURRENT_SOURCE_DIR}/../libs/3rdparty/cplusplus\" PATH_DUMPERS_FILE=\"${CMAKE_CURRENT_SOURCE_DIR}/cplusplus-ast2png/dumpers.inc\")

if (APPLE)
  add_subdirectory(disclaim)
  add_subdirectory(iostool)
endif()

if (WITH_QMLDESIGNER)
  add_subdirectory(qmlpuppet)
  add_subdirectory(sqlitetester)
endif()
add_subdirectory(qtcdebugger) ## windows only
# add_subdirectory(qtcrashhandler)
add_subdirectory(qtc-askpass)
add_subdirectory(qtcreatorcrashhandler)
# add_subdirectory(qtcreatorwidgets) ## qbs does not build this either
add_subdirectory(qtpromaker)
add_subdirectory(sdktool)
add_subdirectory(valgrindfake)
add_subdirectory(wininterrupt) ## windows only

if (EXISTS ${CMAKE_CURRENT_LIST_DIR}/perfparser/CMakeLists.txt)
  add_subdirectory(perfparser)
endif()

add_subdirectory(process_stub)

=== tests/auto/CMakeLists.txt ===
add_subdirectory(aggregation)
add_subdirectory(algorithm)
add_subdirectory(android)
add_subdirectory(changeset)
add_subdirectory(cplusplus)
add_subdirectory(debugger)
add_subdirectory(diff)
add_subdirectory(environment)
add_subdirectory(examples)
add_subdirectory(extensionsystem)
add_subdirectory(externaltool)
add_subdirectory(filesearch)
add_subdirectory(ios)
add_subdirectory(json)
add_subdirectory(languageserverprotocol)
add_subdirectory(pointeralgorithm)
add_subdirectory(profilewriter)
add_subdirectory(qml)
add_subdirectory(sdktool)
add_subdirectory(solutions)
add_subdirectory(texteditor)
add_subdirectory(toolchaincache)
add_subdirectory(tracing)
add_subdirectory(treeviewfind)
add_subdirectory(updateinfo)
add_subdirectory(utils)
add_subdirectory(valgrind)
add_subdirectory(devcontainer)

=== src/libs/devcontainer/CMakeLists.txt ===
add_qtc_library(DevContainer
  PUBLIC_DEPENDS Qt::Core Utils Tasking
  SOURCES
    devcontainer.cpp
    devcontainer.h
    devcontainerconfig.cpp
    devcontainerconfig.h
    devcontainer_global.h
    devcontainertr.h
    substitute.cpp
    substitute.h
)

=== src/libs/solutions/CMakeLists.txt ===
add_subdirectory(spinner)
add_subdirectory(tasking)
add_subdirectory(terminal)

=== src/libs/sqlite/CMakeLists.txt ===
env_with_default("QTC_ENABLE_SQLITE_TRACING" ENV_QTC_ENABLE_SQLITE_TRACING OFF)
option(ENABLE_SQLITE_TRACING "Enable sqlite tarcing" ${ENV_QTC_ENABLE_SQLITE_TRACING})
add_feature_info("Sqlite tracing" ${ENABLE_SQLITE_TRACING} "")

add_qtc_library(SqliteInternal OBJECT
    PROPERTIES AUTOMOC OFF AUTOUIC OFF QT_COMPILE_OPTIONS_DISABLE_WARNINGS ON
    DEFINES SQLITE_CORE SQLITE_CUSTOM_INCLUDE=config.h $<$<CONFIG:Debug>:SQLITE_DEBUG>
    INCLUDES
      ../3rdparty/sqlite
    SOURCES
      ../3rdparty/sqlite
      ../3rdparty/sqlite/sqlite3.c
      ../3rdparty/sqlite/sqlite3.h
      ../3rdparty/sqlite/sqlite3ext.h
      ../3rdparty/sqlite/carray.c
      ../3rdparty/sqlite/config.h
      ../3rdparty/sqlite/sqlite_static_config.h
      ../3rdparty/sqlite/sqlite.h
  SBOM_ARGS
    USE_ATTRIBUTION_FILES
    CREATE_SBOM_FOR_EACH_ATTRIBUTION
    ATTRIBUTION_FILE_PATHS
      "${QtCreator_SOURCE_DIR}/qt_attributions.json"
    ATTRIBUTION_IDS
      sqlite
)

extend_qtc_library(SqliteInternal
  CONDITION QTC_STATIC_BUILD
  PRIVATE_COMPILE_OPTIONS $<IF:$<CXX_COMPILER_ID:MSVC>,/FIsqlite_static_config.h,-includesqlite_static_config.h>
)

if (APPLE)
  extend_qtc_library(SqliteInternal DEFINES _BSD_SOURCE)
elseif (UNIX)
  extend_qtc_library(SqliteInternal DEFINES _POSIX_C_SOURCE=200809L _GNU_SOURCE _DEFAULT_SOURCE)
endif()

add_qtc_library(Sqlite
  PROPERTIES AUTOMOC OFF AUTOUIC OFF
  DEPENDS Qt::Core Threads::Threads ${CMAKE_DL_LIBS} SqliteInternal Nanotrace
  INCLUDES
    ../3rdparty/sqlite
  PUBLIC_INCLUDES
    "${CMAKE_CURRENT_LIST_DIR}"
  DEFINES SQLITE_CUSTOM_INCLUDE=config.h $<$<CONFIG:Debug>:SQLITE_REVERSE>
  SOURCES
    constraints.h
    createtablesqlstatementbuilder.h
    lastchangedrowid.h
    sourcelocation.h
    sqlite3_fwd.h
    sqlitealgorithms.h
    sqlitebasestatement.cpp sqlitebasestatement.h
    sqlitecolumn.h
    sqlitedatabase.cpp sqlitedatabase.h
    sqlitedatabasebackend.cpp sqlitedatabasebackend.h
    sqlitedatabaseinterface.h
    sqliteexception.cpp sqliteexception.h
    sqliteglobal.cpp sqliteglobal.h
    sqlitefunctionregistry.cpp sqlitefunctionregistry.h
    sqliteindex.h
    sqliteprogresshandler.h
    sqlitereadstatement.h
    sqlitereadwritestatement.h
    sqlitesessionchangeset.cpp sqlitesessionchangeset.h
    sqlitesessions.cpp sqlitesessions.h
    sqlitetable.h
    sqlitetracing.cpp sqlitetracing.h
    sqlitetransaction.h
    sqlitevalue.h
    sqlitewritestatement.h
    sqlstatementbuilder.cpp sqlstatementbuilder.h
    sqlstatementbuilderexception.h
    tableconstraints.h
    sqliteblob.h
    sqlitetimestamp.h
    sqlitelibraryinitializer.cpp sqlitelibraryinitializer.h
    sqliteids.h
)

extend_qtc_library(Sqlite
  CONDITION TARGET Nanotrace
  DEPENDS Nanotrace
  PUBLIC_DEFINES
    $<$<BOOL:${ENABLE_SQLITE_TRACING}>:ENABLE_SQLITE_TRACING>
)

extend_qtc_library(Sqlite
  CONDITION QTC_STATIC_BUILD
  PRIVATE_COMPILE_OPTIONS $<IF:$<CXX_COMPILER_ID:MSVC>,/FIsqlite_static_config.h,-includesqlite_static_config.h>
  PROPERTIES
    INTERFACE_COMPILE_OPTIONS $<IF:$<CXX_COMPILER_ID:MSVC>,/FI../3rdparty/sqlite/sqlite_static_config.h,-include../3rdparty/sqlite/sqlite_static_config.h>
)

=== src/libs/utils/CMakeLists.txt ===
add_qtc_library(Utils
  DEPENDS Qt::Qml Qt::Xml Spinner QtCLibArchive
  PUBLIC_DEPENDS
    Qt::Concurrent Qt::Core Qt::Network Qt::Gui Qt::Widgets Qt::PrintSupport
    Tasking
    $<$<BOOL:${QTC_STATIC_BUILD}>:Spinner>
  SOURCES
    ../3rdparty/span/span.hpp
    ../3rdparty/tl_expected/include/tl/expected.hpp
    action.cpp action.h
    algorithm.h
    ansiescapecodehandler.cpp ansiescapecodehandler.h
    appinfo.cpp appinfo.h
    appmainwindow.cpp appmainwindow.h
    array.h
    aspects.cpp aspects.h
    async.cpp async.h
    basetreeview.cpp basetreeview.h
    benchmarker.cpp benchmarker.h
    buildablehelperlibrary.cpp buildablehelperlibrary.h
    builderutils.h
    camelcasecursor.cpp camelcasecursor.h
    categorysortfiltermodel.cpp categorysortfiltermodel.h
    changeset.cpp changeset.h
    checkablemessagebox.cpp checkablemessagebox.h
    classnamevalidatinglineedit.cpp classnamevalidatinglineedit.h
    clangutils.cpp clangutils.h
    codegeneration.cpp codegeneration.h
    commandline.cpp commandline.h
    completinglineedit.cpp completinglineedit.h
    completingtextedit.cpp completingtextedit.h
    cpplanguage_details.h
    crumblepath.cpp crumblepath.h
    datafromprocess.h
    delegates.cpp delegates.h
    detailsbutton.cpp detailsbutton.h
    detailswidget.cpp detailswidget.h
    devicefileaccess.cpp devicefileaccess.h
    deviceshell.cpp deviceshell.h
    differ.cpp differ.h
    displayname.cpp displayname.h
    dropsupport.cpp dropsupport.h
    elfreader.cpp elfreader.h
    elidinglabel.cpp elidinglabel.h
    environment.cpp environment.h
    environmentdialog.cpp environmentdialog.h
    environmentmodel.cpp environmentmodel.h
    environmentfwd.h
    execmenu.cpp execmenu.h
    expected.h
    externalterminalprocessimpl.cpp externalterminalprocessimpl.h
    fadingindicator.cpp fadingindicator.h
    faketooltip.cpp faketooltip.h
    fancyiconbutton.cpp fancyiconbutton.h
    fancylineedit.cpp fancylineedit.h
    fancymainwindow.cpp fancymainwindow.h
    filecrumblabel.cpp filecrumblabel.h
    fileinprojectfinder.cpp fileinprojectfinder.h
    filenamevalidatinglineedit.cpp filenamevalidatinglineedit.h
    filepath.cpp filepath.h
    filepathinfo.h
    filesearch.cpp filesearch.h
    filestreamer.cpp filestreamer.h
    filestreamermanager.cpp filestreamermanager.h
    filesystemmodel.cpp filesystemmodel.h
    filesystemwatcher.cpp filesystemwatcher.h
    fileutils.cpp fileutils.h
    filewizardpage.cpp filewizardpage.h
    fsengine/fsengine.cpp fsengine/fsengine.h
    fsengine/fileiconprovider.cpp fsengine/fileiconprovider.h
    futuresynchronizer.cpp futuresynchronizer.h
    fuzzymatcher.cpp fuzzymatcher.h
    genericconstants.h
    globalfilechangeblocker.cpp globalfilechangeblocker.h
    globaltasktree.cpp globaltasktree.h
    guard.cpp guard.h
    guardedcallback.h
    guiutils.cpp guiutils.h
    headerviewstretcher.cpp headerviewstretcher.h
    highlightingitemdelegate.cpp highlightingitemdelegate.h
    historycompleter.cpp historycompleter.h
    hostosinfo.cpp hostosinfo.h
    htmldocextractor.cpp htmldocextractor.h
    icon.cpp icon.h
    icondisplay.h icondisplay.cpp
    id.cpp id.h
    indexedcontainerproxyconstiterator.h
    infobar.cpp infobar.h
    infolabel.cpp infolabel.h
    itemviews.cpp itemviews.h
    jsontreeitem.cpp jsontreeitem.h
    layoutbuilder.cpp layoutbuilder.h
    lazy.h
    link.cpp link.h
    listmodel.h
    listutils.h
    lua.cpp lua.h
    macroexpander.cpp macroexpander.h
    markdownbrowser.cpp markdownbrowser.h
    mathutils.cpp mathutils.h
    mimeconstants.h
    mimeutils.h
    minimizableinfobars.cpp
    minimizableinfobars.h
    multitextcursor.cpp multitextcursor.h
    namevaluedictionary.cpp namevaluedictionary.h
    namevaluedictionary.cpp namevaluedictionary.h
    namevalueitem.cpp namevalueitem.h
    namevaluesdialog.cpp namevaluesdialog.h
    namevaluevalidator.cpp namevaluevalidator.h
    navigationtreeview.cpp navigationtreeview.h
    networkaccessmanager.cpp networkaccessmanager.h
    optionpushbutton.h
    optionpushbutton.cpp
    osspecificaspects.h
    outputformat.h
    outputformatter.cpp outputformatter.h
    overlaywidget.cpp overlaywidget.h
    overloaded.h
    overridecursor.cpp overridecursor.h
    passworddialog.cpp passworddialog.h
    pathchooser.cpp pathchooser.h
    pathlisteditor.cpp pathlisteditor.h
    persistentsettings.cpp persistentsettings.h
    pointeralgorithm.h
    port.cpp port.h
    portlist.cpp portlist.h
    predicates.h
    processenums.h
    processhandle.cpp processhandle.h
    processhelper.cpp processhelper.h
    processinfo.cpp processinfo.h
    processinterface.cpp processinterface.h
    processreaper.cpp processreaper.h
    progressdialog.cpp progressdialog.h
    progressindicator.cpp progressindicator.h
    projectintropage.cpp projectintropage.h
    proxyaction.cpp proxyaction.h
    qrcparser.cpp qrcparser.h
    qtcassert.cpp qtcassert.h
    qtcolorbutton.cpp qtcolorbutton.h
    qtcprocess.cpp qtcprocess.h
    qtcsettings.cpp qtcsettings.h qtcsettings_p.h
    qtcwidgets.cpp qtcwidgets.h
    ranges.h
    reloadpromptutils.cpp reloadpromptutils.h
    removefiledialog.cpp removefiledialog.h
    result.cpp result.h
    savefile.cpp savefile.h
    scopedswap.h
    scopedtimer.cpp scopedtimer.h
    searchresultitem.cpp searchresultitem.h
    set_algorithm.h
    settingsaccessor.cpp settingsaccessor.h
    settingsselector.cpp settingsselector.h
    shutdownguard.cpp shutdownguard.h
    sizedarray.h
    smallstring.h
    smallstringfwd.h
    smallstringio.h
    smallstringiterator.h
    smallstringlayout.h
    smallstringliteral.h
    smallstringmemory.h
    smallstringvector.h
    smallstringview.h
    sortfiltermodel.h
    span.h
    statuslabel.cpp statuslabel.h
    store.cpp store.h
    storekey.h
    stringtable.cpp stringtable.h
    stringutils.cpp stringutils.h
    styleanimator.cpp styleanimator.h
    styledbar.cpp styledbar.h
    stylehelper.cpp stylehelper.h
    summarywidget.cpp summarywidget.h
    synchronizedvalue.h
    templateengine.cpp templateengine.h
    temporarydirectory.cpp temporarydirectory.h
    temporaryfile.cpp temporaryfile.h
    terminalcommand.cpp terminalcommand.h
    terminalhooks.cpp terminalhooks.h
    terminalinterface.cpp terminalinterface.h
    textcodec.cpp textcodec.h
    textfieldcheckbox.cpp textfieldcheckbox.h
    textfieldcombobox.cpp textfieldcombobox.h
    textfileformat.cpp textfileformat.h
    textutils.cpp textutils.h
    theme/theme.cpp theme/theme.h theme/theme_p.h
    threadutils.cpp threadutils.h
    tooltip/effects.h
    tooltip/tips.cpp tooltip/tips.h
    tooltip/tooltip.cpp tooltip/tooltip.h
    touchbar/touchbar.h
    transientscroll.cpp transientscroll.h
    treemodel.cpp treemodel.h
    treeviewcombobox.cpp treeviewcombobox.h
    unarchiver.cpp unarchiver.h
    uncommentselection.cpp uncommentselection.h
    uniqueobjectptr.h
    unixutils.cpp unixutils.h
    url.cpp url.h
    utils.qrc
    utils_global.h
    utilstr.h
    utilsicons.cpp utilsicons.h
    utiltypes.h
    utility.h
    variablechooser.cpp variablechooser.h
    winutils.cpp winutils.h
    wizard.cpp wizard.h
    wizardpage.cpp wizardpage.h
    movie.cpp movie.h
  SBOM_ARGS
    USE_ATTRIBUTION_FILES
    CREATE_SBOM_FOR_EACH_ATTRIBUTION
    ATTRIBUTION_FILE_PATHS
      "${QtCreator_SOURCE_DIR}/qt_attributions.json"
    ATTRIBUTION_IDS
      std-span-martinmoene
      tartanllama-expected
      tika-mimetypes
)

extend_qtc_library(Utils
  SOURCES_PREFIX mimetypes2
  PUBLIC_INCLUDES mimetypes2
  SOURCES
    mimedatabase.cpp
    mimedatabase.h
    mimedatabase_p.h
    mimeglobpattern.cpp
    mimeglobpattern_p.h
    mimemagicrule.cpp
    mimemagicrule_p.h
    mimemagicrulematcher.cpp
    mimemagicrulematcher_p.h
    mimeprovider.cpp
    mimeprovider_p.h
    mimetype.cpp
    mimetype.h
    mimetype_p.h
    mimetypeparser.cpp
    mimetypeparser_p.h
    mimeutils.cpp
)

extend_qtc_library(Utils
  SOURCES_PREFIX plaintextedit
  PUBLIC_INCLUDES plaintextedit
  SOURCES
    inputcontrol.cpp
    inputcontrol.h
    plaintextedit.cpp
    plaintextedit.h
    plaintexteditaccessibility.cpp
    plaintexteditaccessibility.h
    texteditorlayout.cpp
    texteditorlayout.h
    widgettextcontrol.cpp
    widgettextcontrol.h
)

if (MSVC)
    find_library(DbgHelpLib dbghelp)
endif()

extend_qtc_library(Utils CONDITION MSVC
  DEPENDS ${DbgHelpLib}
  DEFINES HAVE_DBGHELP
)

extend_qtc_library(Utils CONDITION WIN32
  SOURCES
    touchbar/touchbar.cpp
  DEPENDS
    user32 iphlpapi ws2_32 shell32 ole32
  DEFINES
    _UNICODE UNICODE
  PUBLIC_DEFINES
    _CRT_SECURE_NO_WARNINGS _SCL_SECURE_NO_WARNINGS
)

extend_qtc_library(Utils CONDITION APPLE
  SOURCES
    fileutils_mac.mm fileutils_mac.h
    processhandle_mac.mm
    theme/theme_mac.mm theme/theme_mac.h
    touchbar/touchbar_appdelegate_mac.mm touchbar/touchbar_appdelegate_mac_p.h
    touchbar/touchbar_mac.mm touchbar/touchbar_mac_p.h
  DEPENDS
    ${FWFoundation} ${FWAppKit}
)

extend_qtc_library(Utils CONDITION UNIX AND NOT APPLE
  SOURCES
    touchbar/touchbar.cpp
)

extend_qtc_library(Utils
  CONDITION TARGET Qt::CorePrivate
  DEPENDS Qt::CorePrivate ptyqt
  DEFINES QTC_UTILS_WITH_FSENGINE
  SOURCES fsengine/diriterator.h
          fsengine/fileiteratordevicesappender.h
          fsengine/fixedlistfsengine.h
          fsengine/fsenginehandler.cpp
          fsengine/fsenginehandler.h
          fsengine/filepathinfocache.h
  SBOM_ARGS
    ATTRIBUTION_FILE_PATHS
      "${QtCreator_SOURCE_DIR}/qt_attributions.json"
    ATTRIBUTION_IDS
      ptyqt
      ptyqt-conpty
)

extend_qtc_library(Utils
  CONDITION TARGET Nanotrace
  DEPENDS Nanotrace
)

if (WIN32)
  add_qtc_executable(qtcreator_ctrlc_stub
    DEPENDS user32 shell32
    DEFINES _UNICODE UNICODE _CRT_SECURE_NO_WARNINGS
    SOURCES
      process_ctrlc_stub.cpp
  )
endif()

=== debian/changelog ===
qtcreator (18.0.0-0zneon+24.04+noble+stable+build15) noble; urgency=medium

  * Automatic CI Build

 -- Neon CI <neon@kde.org>  Tue, 02 Dec 2025 03:02:04 +0000

qtcreator (18.0.0-0neon) noble; urgency=medium

  * New release

 -- Carlos De Maine <carlosd.kde@gmail.com>  Tue, 02 Dec 2025 08:54:14 +1000

=== debian/control ===
Source: qtcreator
Section: devel
Priority: optional
Uploaders: Adam Majer <adamm@zombino.com>,
           Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>
Build-Depends: clang (>= 1:10~),
               clangd (>= 1:14~),
               cmake,
               debhelper-compat (= 13),
               diffutils,
               golang,
               libappstream-glib-dev,
               libclang-14-dev,
               libclang-dev (>= 1:10~),
               libdw-dev,
               libedit-dev,
               libelf-dev,
               libicu-dev,
               libqt-advanced-docking-system-dev,
               librust-rustc-demangle-dev,
               libsecret-1-dev,
               libsqlite3-dev,
               libsystemd-dev,
               libyaml-cpp-dev (>= 0.5~),
               libzstd-dev,
               llvm-dev (>= 1:10~),
               ninja-build,
               pkg-config,
               python3:any,
               qt6-5compat-dev,
               qt6-base-dev,
               qt6-base-doc,
               qt6-declarative-dev,
               qt6-declarative-private-dev,
               qt6-doc-dev,
               qt6-quick3d-dev,
               qt6-quicktimeline-dev,
               qt6-serialport-dev,
               qt6-shadertools-dev,
               qt6-svg-dev,
               qt6-tools-dev,
               qt6-tools-private-dev,
               qt6-webengine-dev
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://doc.qt.io/qt-5/topics-app-development.html
Vcs-Git: https://invent.kde.org/neon/qt6/qtcreator.git
Vcs-Browser: https://invent.kde.org/neon/qt6/qtcreator
Maintainer: Neon CI <neon@kde.org>

Package: qtcreator
Architecture: any
Depends: clangd (>= 1:14~),
         libqt6sql6-sqlite,
         qml6-module-qtqml-models,
         qml6-module-qtqml-workerscript,
         qml6-module-qtquick,
         qml6-module-qtquick-controls,
         qml6-module-qtquick-layouts,
         qtcreator-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: clang-tidy,
            gdb,
            make,
            qml-qt6,
            qt6-base-dev-tools,
            qt6-declarative-dev-tools,
            qt6-qmltooling-plugins,
            qt6-tools-dev-tools,
            qt6-translations-l10n,
            qtcreator-doc,
            xterm | x-terminal-emulator
Suggests: clazy (>= 1.5),
          cmake,
          g++,
          git,
          meson,
          python3-pylsp,
          subversion,
          valgrind
Description: integrated development environment (IDE) for Qt
 Qt Creator is a cross-platform integrated development environment (IDE)
 designed to make development with the Qt application framework faster
 and easier.
 .
 It includes:
  * An advanced C++ code editor
  * Integrated GUI layout and forms designer
  * Project and build management tools
  * Integrated, context-sensitive help system
  * Visual debugger
  * Rapid code navigation tools
  * Supports multiple platforms
  * Qt Quick Designer

Package: qtcreator-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: application data for Qt Creator IDE
 This package contains architecture-independent data for Qt Creator IDE.

Package: qtcreator-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: qt6-imageformats, ${misc:Depends}
Description: documentation for Qt Creator IDE
 Qt Creator is a cross-platform integrated development environment (IDE)
 designed to make development with the Qt application framework faster
 and easier.
 .
 This package contains documentation for Qt Creator IDE.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk

# Do not build the HelloWorld plugin, as it is not needed
export QTC_BUILD_PLUGIN_HELLOWORLD=FALSE

# The upstream version of a package passed as parameter
upstream_version_of_pkg = $(shell dpkg-query -f '$${Version}' -W $(1) | sed -e 's/-[^-]*$$//')

# the dwz processing for all the libraries and plugins can take a lot of memory,
# which may be not enough on some architectures (typically 32bit), resulting in
# dwz failing with "Could not allocate memory: Cannot allocate memory" errors;
# hence, on architectures where we see this result, try to use a more memory
# friendly processing for a lower number of DIEs (dwz default is 10M)
archs_with_dwz_low_mem = armel armhf mipsel
dwz_low_mem = 3000000

archs_using_clang = mips64el mipsel
ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(archs_using_clang)))
export CC=clang
export CXX=clang++
export DEB_CFLAGS_MAINT_APPEND := -gdwarf-4
export DEB_CXXFLAGS_MAINT_APPEND := -gdwarf-4
export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed
EXTRA_CMAKE_ARGS += -DBUILD_WITH_PCH=OFF
endif

%:
	dh $@ --builddirectory=builddir

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- \
		-DBUILD_DEVELOPER_DOCS=ON \
		-DBUILD_QBS=OFF \
		-Djournald=ON \
		-DWITH_TESTS=OFF \
		-DBUILD_TESTING=OFF \
		-DCLANGTOOLING_LINK_CLANG_DYLIB=ON \
		-DBUILD_PLUGIN_CLANGREFACTORING=ON \
		-DBUILD_PLUGIN_CLANGPCHMANAGER=ON \
		-DCMAKE_DISABLE_FIND_PACKAGE_litehtml=yes \
		-DEXTERNAL_XXD=no \
		-DWITH_DOCS=$(if $(filter qtcreator-doc, $(shell dh_listpackages)),ON,OFF) \
		$(EXTRA_CMAKE_ARGS)

execute_after_dh_auto_build-indep:
	dh_auto_build -- docs

execute_after_dh_auto_install:
ifneq (,$(filter qtcreator-doc, $(shell dh_listpackages)))
	DESTDIR=$(CURDIR)/debian/tmp cmake --install $(CURDIR)/builddir --component qch_docs
	DESTDIR=$(CURDIR)/debian/tmp cmake --install $(CURDIR)/builddir --component html_docs
endif

	# Not needed
	#rm debian/tmp/usr/bin/qtcreator.sh

	# License files of the embedded copy of KSyntaxHighlighting
	rm -rf debian/tmp/usr/share/qtcreator/generic-highlighter/syntax/licenses/

	# Remove extra exec permissions
	find debian/tmp -name qmldir -type f -perm /111 -exec chmod -v -x {} \;

execute_after_dh_install:
	# Copied in qtcreator-doc already
	rm -rf debian/qtcreator-data/usr/share/qtcreator/doc/

override_dh_makeshlibs:
	dh_makeshlibs -Xusr/lib/$(DEB_HOST_MULTIARCH)/qtcreator/

override_dh_shlibdeps:
	echo 'libQt6DesignerComponents 6 qt6-tools (>= $(call upstream_version_of_pkg,qt6-tools)~)' > debian/shlibs.local
	dh_shlibdeps -l$(CURDIR)/debian/qtcreator/usr/lib/$(DEB_HOST_MULTIARCH)/qtcreator
	rm debian/shlibs.local

ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(archs_with_dwz_low_mem)))
override_dh_dwz:
	dh_dwz -- --low-mem-die-limit $(dwz_low_mem)
endif

.PHONY: override_dh_strip 

override_dh_strip:
		dh_strip --exclude=/usr/libexec/qtcreator/cmdbridge-linux-amd64 --exclude=/usr/libexec/qtcreator/cmdbridge-linux-arm64

=== debian/watch ===
version=4
opts=uversionmangle=s/-/~/ \
https://mirror.netcologne.de/qtproject/official_releases/qtcreator/([\d\.]*)/([\d\.]*)/qt-creator-opensource-src-([^-]*)\.tar\.xz

## qtcreator 18.0.1

=== src/share/3rdparty/CMakeLists.txt ===
set(resource_directories
  fonts
  package-manager
)

# create install rule for resource directories
install(
  DIRECTORY ${resource_directories}
  DESTINATION "${IDE_DATA_PATH}"
  USE_SOURCE_PERMISSIONS
)

# copy resource directories during build
qtc_copy_to_builddir(copy_fonts_to_builddir
  DIRECTORIES ${resource_directories}
  DESTINATION "${IDE_DATA_PATH}"
  CREATE_SUBDIRS
)

file(GLOB_RECURSE package_manager_files package-manager/*)
qtc_add_sbom(PackageManagerResources
  SBOM_ENTITY_TYPE RESOURCES
  LICENSE_EXPRESSION "MIT"
  USE_ATTRIBUTION_FILES
  ATTRIBUTION_FILE_PATHS
    "${QtCreator_SOURCE_DIR}/qt_attributions.json"
  ATTRIBUTION_IDS
    conan.cmake
)

qtc_sbom_add_files(PackageManagerResources
  FILES "${package_manager_files}"
  FILE_TYPE "RESOURCES"
  INSTALL_PATH "${IDE_DATA_PATH}/package-manager"
)

file(GLOB_RECURSE fonts_files fonts/*)
qtc_add_sbom(FontsResources
  SBOM_ENTITY_TYPE RESOURCES
  LICENSE_EXPRESSION "OFL-1.1-RFN"
  USE_ATTRIBUTION_FILES
  ATTRIBUTION_FILE_PATHS
    "${QtCreator_SOURCE_DIR}/qt_attributions.json"
  ATTRIBUTION_IDS
    source-code-pro-font
)

qtc_sbom_add_files(FontsResources
  FILES "${fonts_files}"
  FILE_TYPE "RESOURCES"
  INSTALL_PATH "${IDE_DATA_PATH}/fonts"
)

=== debian/changelog ===
qtcreator (18.0.1-1) unstable; urgency=medium

  * New upstream release.
  * Switch the qt6-base-dev-tools recommend to qt6-base-dev, so it is possible
    to build using Qt 6 by default. (Closes: #1109037)

 -- Pino Toscano <pino@debian.org>  Tue, 16 Dec 2025 18:47:32 +0100

qtcreator (18.0.0-1) unstable; urgency=medium

  * Upload to unstable.
  * New upstream release.
  * Switch Vcs-* fields back to the 'master' packaging branch.
  * Switch watch file back to stable releases.

 -- Pino Toscano <pino@debian.org>  Thu, 30 Oct 2025 11:21:32 +0100

=== debian/control ===
Source: qtcreator
Section: devel
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Adam Majer <adamm@zombino.com>,
           Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>,
           Pino Toscano <pino@debian.org>,
Build-Depends: clang (>= 1:14~),
               clangd (>= 1:17~),
               cmake (>= 3.16~),
               debhelper-compat (= 13),
               libarchive-dev,
               libclang-dev (>= 1:14~),
               libdw-dev,
               libsecret-1-dev,
               libyaml-cpp-dev (>= 0.5~),
               libzstd-dev,
               llvm-dev (>= 1:14~),
               pkgconf,
               python3:any,
               qt6-base-dev (>= 6.7.3~),
               qt6-base-private-dev (>= 6.5.4~),
               qt6-charts-dev (>= 6.5.4~),
               qt6-declarative-dev (>= 6.5.4~),
               qt6-declarative-private-dev (>= 6.5.4~),
               qt6-quick3d-dev (>= 6.5.4~),
               qt6-quick3d-private-dev (>= 6.5.4~),
               qt6-quicktimeline-dev (>= 6.5.4~),
               qt6-serialport-dev (>= 6.5.4~),
               qt6-shadertools-dev (>= 6.5.4~),
               qt6-svg-dev (>= 6.5.4~),
               qt6-tools-dev (>= 6.5.4~),
               qt6-tools-private-dev (>= 6.5.4~),
               qt6-websockets-dev (>= 6.5.4~),
               xxd,
               zlib1g-dev,
Standards-Version: 4.7.2
Homepage: https://doc.qt.io/qt-5/topics-app-development.html
Vcs-Git: https://salsa.debian.org/qt-kde-team/qt/qtcreator.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/qt/qtcreator

Package: qtcreator
Architecture: any
Depends: clangd (>= 1:17~),
         libqt6sql6-sqlite,
         qml6-module-qtqml-models,
         qml6-module-qtqml-workerscript,
         qml6-module-qtquick-controls,
         qml6-module-qtquick-layouts,
         qml6-module-qtquick,
         qtcreator-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: clang-tidy,
            gdb,
            make,
            qml-qt6,
            qt6-qmltooling-plugins,
            qt6-base-dev,
            qtcreator-doc,
            qt6-declarative-dev-tools,
            qt6-tools-dev-tools,
            qt6-translations-l10n,
            xterm | x-terminal-emulator
Suggests: clazy (>= 1.5), cmake, g++, git, meson, subversion, valgrind,
          python3-pylsp,
Description: integrated development environment (IDE) for Qt
 Qt Creator is a cross-platform integrated development environment (IDE)
 designed to make development with the Qt application framework faster
 and easier.
 .
 It includes:
  * An advanced C++ code editor
  * Integrated GUI layout and forms designer
  * Project and build management tools
  * Integrated, context-sensitive help system
  * Visual debugger
  * Rapid code navigation tools
  * Supports multiple platforms
  * Qt Quick Designer

Package: qtcreator-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: application data for Qt Creator IDE
 This package contains architecture-independent data for Qt Creator IDE.

Package: qtcreator-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: qt6-image-formats-plugins,
         ${misc:Depends},
Description: documentation for Qt Creator IDE
 Qt Creator is a cross-platform integrated development environment (IDE)
 designed to make development with the Qt application framework faster
 and easier.
 .
 This package contains documentation for Qt Creator IDE.
